SystemOrganization addCategory: 'OrbeonBPMCore'!

Exception subclass: #OrbeonBpmException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #BrokenProcessVersionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #EvaluationNotBlockException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #EvaluationNotBooleanException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #FormToProcessDefinitionMappingException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #NoAnonymousStartException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #NoCreationPermissionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #NoProcessNameException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #NoSuchActivitytException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

OrbeonBpmException subclass: #NoSuchRoleException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!AbstractApplication methodsFor: '*orbeonBPMCore' stamp: 'BrunoBB 02/29/2016 10:02'!
canDelete
	"Answer whether or not the receiver can be deleted from the system"

	^(BpmBackofficeRole getRolsInAppName: applicationName) isEmpty and: [
		(BpmFrontOfficeRole getRolsInAppName: applicationName) isEmpty and: [
		(BpmProcessDefinition hasAnyProcessApplicationNamed: applicationName) not
		]]! !

AbstractApplication subclass: #BpmApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmApplication class methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:23'!
applicationNamed: aString ifNone: aBlock
	"Answer an OrbeonApplication or BpmApplication named <aString> if none evaluates the zero block argument <aBlock>"

	^self getBpmCache detect: [:each | each applicationName = aString] ifNone: aBlock! !

!BpmApplication methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 16:32'!
getApplicationNameForCombo

	^applicationName , ' [BpmApp]'! !

!BpmApplication methodsFor: 'other' stamp: 'BrunoBB 02/24/2016 15:23'!
getLastDefinitions
	"No Orbeon definitions - for compability with Orbeon integration"

	^Dictionary new! !

Object subclass: #BpmObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmObject subclass: #BpmArtifactDefinition
	instanceVariableNames: 'processDefinition name inTransitions outTransitions roles extendedAttributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmArtifactDefinition subclass: #BpmActivityDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmActivityDefinition subclass: #BpmAbstractTaskDefinition
	instanceVariableNames: 'loop performers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/31/2015 14:02'!
addPerformer: aBpmParticipantDefinition

	^performers add: aBpmParticipantDefinition! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 09:08'!
getExpectedResult

	^self extendedValueOf: 'expectedResult' ifAbsent: [OrderedCollection new]! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2016 16:03'!
getFirstPerformerIfNone: aBlock

	^performers notEmpty
		ifTrue: [performers first]
		ifFalse: aBlock! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 04/13/2016 12:07'!
getFirstPerformerName
	"The receiver answer the name of the first performers if there is no performers answer an empty string"

	^self hasPerformers 
		ifTrue: [performers first name] 
		ifFalse: ['']! !

!BpmAbstractTaskDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 03/05/2016 10:18'!
getPreviousFields
	"The receiver answer a collection of fields to show that belong to previous tasks"

	^((self extendedValueOf: 'previousFields' ifAbsent: [^OrderedCollection new]) subStrings: ' ') collect: [:each | each trimBlanks]! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 12:26'!
getRoleForPerformer: aBpmRoleParticipantDefinition
	"The receiver answer the associated <BpmRole> to the participant <aBpmRoleParticipantDefinition>"

	^roles detect: [:each | each name = aBpmRoleParticipantDefinition name] ifNone: [nil]! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 13:30'!
hasLoop

	^loop notNil! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 04/13/2016 10:16'!
hasPerformers
	"Answer whether or not the receiver has performers.
	Regular task consist in one form or one Seaside Component.
	Task with performers enable to more than one role work in the same task (in sequential way)"

	^performers size > 1! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 03/23/2016 09:13'!
initialize

	super initialize.

	performers := OrderedCollection new.! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 01/19/2016 12:28'!
isGrantedUser: aBpmUser
	"Answer whether or not the user <aBpmUser> is granted in the receiver.
	If there is NO <performers> in the receiver --> check in each role of the receiver if the user <aBpmUser> is granted on it.
	If there is <performers> in the receiver --> check in each role of the user <aBpmUser> and try to mapp it to any <performer> of the receiver. 
		If succeed --> is granted, else --> not granted"

	self hasPerformers 
	ifFalse: [^roles anySatisfy: [:each | each isGranted: aBpmUser]].

	^self performers anySatisfy: [:eachPerformer | | mappedRole |

		mappedRole := aBpmUser roles detect: [:eachRole | (eachRole name = eachPerformer name) and:[eachRole getApplicationName = self applicationName]] 
									ifNone: [nil].

		mappedRole ifNotNil: [mappedRole isGranted: aBpmUser] ifNil: [false].
	]! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/28/2015 09:07'!
isMultiInstance

	^self hasLoop and: [loop isMultiInstance]! !

!BpmAbstractTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 10:51'!
isTaskDefinition

	^true! !

!BpmAbstractTaskDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 11/01/2015 13:30'!
loop
	^loop! !

!BpmAbstractTaskDefinition methodsFor: 'Updating' stamp: 'BrunoBB 11/01/2015 13:30'!
loop: newValue
	loop := newValue! !

!BpmAbstractTaskDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/31/2015 13:53'!
performers
	^performers! !

!BpmAbstractTaskDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/31/2015 13:53'!
performers: newValue
	performers := newValue! !

BpmAbstractTaskDefinition subclass: #BpmSubProcessTaskDefinition
	instanceVariableNames: 'subProcessDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:22'!
addToParentProcess

	^processDefinition addSubProcessTask: self! !

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/01/2015 11:51'!
createProcessInstance: aBpmUser
	"Create a new process instance based on the receiver if the user <aBpmUser> does not have creation permission throw an exception.
	The new process can be a main process or a subprocess <BpmMainProcessInstance> <BpmSubProcessInstance>"

	^subProcessDefinition createProcessInstance: aBpmUser! !

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/01/2015 12:59'!
instanceClass

	^BpmSubProcessTaskInstance! !

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 06:43'!
isSubprocessDefinition

	^true! !

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 03/21/2016 15:51'!
printNameAndDefinitionType

	^'Subprocess [', self name, ']'! !

!BpmSubProcessTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:15'!
printOnType

	^'S'! !

!BpmSubProcessTaskDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/10/2015 05:49'!
setSubProcessDefinition: aBpmSubProcessDefinition

	subProcessDefinition := aBpmSubProcessDefinition.

	processDefinition addSubProcess: aBpmSubProcessDefinition! !

!BpmSubProcessTaskDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:10'!
subProcessDefinition
	^subProcessDefinition! !

!BpmSubProcessTaskDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:10'!
subProcessDefinition: newValue
	subProcessDefinition := newValue! !

BpmAbstractTaskDefinition subclass: #BpmTaskDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTaskDefinition subclass: #BpmOrbeonTaskDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmOrbeonTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 04/09/2016 09:22'!
getComponentClass
	"Answer the OrbeonFormDefinition associated with the receiver.
	The name of the task and the name of the OrbeonFormDefinition MUST be the same.
	Also each time a task is created it get the lastest version of the OrbeonFormDefinition "

	^processDefinition application definitionNamed: name ifNone: [nil]! !

!BpmOrbeonTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 02/23/2016 09:13'!
getObjectModel

	^self getComponentClass! !

!BpmOrbeonTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:58'!
instanceClass

	^BpmOrbeonTaskInstance! !

!BpmOrbeonTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 15:50'!
isOrbeonTask

	^true! !

!BpmOrbeonTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 06:38'!
printNameAndDefinitionType

	^name, ' [O]'! !

BpmTaskDefinition subclass: #BpmSeasideTaskDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmSeasideTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 02/19/2016 13:31'!
getComponentClass
	| seasideComponent |

	seasideComponent := Smalltalk at: (self extendedValueOf: 'seasideComponent' ifAbsent: [^nil]) asSymbol.

	^seasideComponent! !

!BpmSeasideTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 02/19/2016 13:32'!
getObjectModel

	^self getComponentClass 
			ifNotNil: [:value | value defaultModel]
			ifNil: [nil]! !

!BpmSeasideTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:59'!
instanceClass

	^BpmSeasideTaskInstance! !

!BpmSeasideTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 06:38'!
printNameAndDefinitionType

	^name, ' [C]'! !

!BpmSeasideTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 02/19/2016 13:43'!
taskName

	^self getObjectModel getObjectName! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:22'!
addToParentProcess

	^processDefinition addTask: self! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 02/17/2016 11:22'!
getComponentClass

	^self subclassResponsibility! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 02/23/2016 09:13'!
getObjectModel

	^self subclassResponsibility! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:39'!
instanceClass

	^BpmOrbeonTaskInstance! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 06:37'!
printNameAndDefinitionType

	^self subclassResponsibility! !

!BpmTaskDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:15'!
printOnType

	^'T'! !

BpmActivityDefinition subclass: #BpmGatewayDefinition
	instanceVariableNames: 'waitAllIncoming defaultTransition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmGatewayDefinition subclass: #BpmComplexGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmComplexGatewayDefinition commentStamp: 'BrunoBB 11/23/2015 13:33' prior: 0!
(*)
As the name signifies, complex gateways are only used for the most complex flows in the business process. When possible, you should use a simpler gateway to do what needs to be done. If you need multiple gateways to describe the business flow, then that's an ideal case for the complex gateway. Complex gateways need more descriptive text because you're using words in place of symbols.

Splitting: the flow will go down one or more paths depending on the evaluation of a single condition specified for the Gateway. 

Merging: the Gateway synchronizes all incoming paths that meet a single condition specified for the Gateway.!

!BpmComplexGatewayDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 11/23/2015 13:40'!
createInstanceOn: aBpmProcessInstance

	^(self instanceClass definition: self)
		process: aBpmProcessInstance;
		yourself! !

!BpmComplexGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/23/2015 13:40'!
initialize

	super initialize.

	waitAllIncoming := false. "whether or not wait for processing until all incoming transition are done"! !

!BpmComplexGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:36'!
instanceClass

	^BpmComplexGateway! !

BpmGatewayDefinition subclass: #BpmEventBasedGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmEventBasedGatewayDefinition commentStamp: 'BrunoBB 11/23/2015 13:33' prior: 0!
Splitting: the flow goes down only one of the paths that originate in the Gateway depending on the occurrence of a specified Event. 

Merging: it has the same behavior as the Exclusive Gateway.!

!BpmEventBasedGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:37'!
instanceClass

	^BpmEventBasedGateway! !

BpmGatewayDefinition subclass: #BpmExclusiveEventBasedGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmExclusiveEventBasedGatewayDefinition commentStamp: 'BrunoBB 11/23/2015 13:33' prior: 0!
An event-based gateway is similar to a exclusive gateway because both involve one path in the flow. In the case of an event-based gateway, however, you are evaluating which event has occurred, not which condition is being met.!

!BpmExclusiveEventBasedGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:37'!
instanceClass

	^BpmExclusiveEventBasedGateway! !

BpmGatewayDefinition subclass: #BpmExclusiveGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmExclusiveGatewayDefinition commentStamp: 'BrunoBB 11/23/2015 13:33' prior: 0!
(X)
An exclusive gateway evaluates the state of the business process andbased on the conditionbreaks the flow into one of the two or more mutually exclusive paths. Remember that the exclusive in "exclusive gateway" stands for mutually exclusive.

Splitting: the flow will go down only one of the paths that originate in the Gateway; the selection will be made after evaluating the conditions defined for the Gateway (there will be one per each path). 

Merging: when multiple paths reach the Gateway, it simply allows the flow to continue without evaluating any conditions or making any synchronization.!

!BpmExclusiveGatewayDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 01/22/2016 12:15'!
createInstanceOn: aBpmProcessInstance
	"The receiver create a concrete instance of it self.
	If it is Splitting --> create the instance.
	If it is Merging --> check if there is a running gateway of it self if not then create the instance"

	self isSplitting 
	ifTrue: [^self createNewGatewayOn: aBpmProcessInstance].

	"--> isMerging"

	^(aBpmProcessInstance hasRunningGatewayNamed: name)
	ifTrue: [aBpmProcessInstance getRunningGatewayNamed: name]
	ifFalse: [self createNewGatewayOn: aBpmProcessInstance].! !

!BpmExclusiveGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/23/2015 13:38'!
initialize

	super initialize.

	waitAllIncoming := false. "whether or not wait for processing until all incoming transition are done"! !

!BpmExclusiveGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:37'!
instanceClass

	^BpmExclusiveGateway! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:22'!
addToParentProcess

	^processDefinition addGateway: self! !

!BpmGatewayDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 11/24/2015 13:31'!
createNewGatewayOn: aBpmProcessInstance
	| newGateway |

	newGateway := (self instanceClass definition: self)
								process: aBpmProcessInstance;
								yourself.

	aBpmProcessInstance startGateway: newGateway. "add the gateway to running gateways collection"

	^newGateway! !

!BpmGatewayDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 11/23/2015 13:37'!
defaultTransition
	^defaultTransition! !

!BpmGatewayDefinition methodsFor: 'Updating' stamp: 'BrunoBB 11/23/2015 13:37'!
defaultTransition: newValue
	defaultTransition := newValue! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 04/19/2016 16:21'!
hasEvaluationConditionWithFieldNamed: fieldName
	"Answer whether or not the field named <fieldName> is included in the evaluation expression of the receiver"

	^outTransitions anySatisfy: [:each | each hasEvaluationConditionWithFieldNamed: fieldName]! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/23/2015 13:38'!
initialize

	super initialize.

	waitAllIncoming := false. "whether or not wait for processing until all incoming transition are done"! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/28/2015 14:18'!
isMerging
	"Answer whether or not the receiver is merging the process path"

	^(inTransitions size > 1) and: [outTransitions size = 1]! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/28/2015 14:19'!
isSplitting
	"Answer whether or not the receiver is splitting the process path"

	^(inTransitions size = 1) and: [outTransitions size > 1]! !

!BpmGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:14'!
printOnType

	^'G'! !

!BpmGatewayDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 11/23/2015 13:34'!
waitAllIncoming
	^waitAllIncoming! !

!BpmGatewayDefinition methodsFor: 'Updating' stamp: 'BrunoBB 11/23/2015 13:34'!
waitAllIncoming: newValue
	waitAllIncoming := newValue! !

BpmGatewayDefinition subclass: #BpmInclusiveGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmInclusiveGatewayDefinition commentStamp: 'BrunoBB 11/23/2015 13:33' prior: 0!
(O)
An inclusive gateway breaks the process flow into one or more flows. An example of a inclusive gateway is business actions taken based on survey results.

Splitting: the flow will go down all the outgoing paths that meet the Gateways conditions (there will be one per each path). 

Merging: it synchronizes all the paths where the process flow effectively reaches the gateway.!

!BpmInclusiveGatewayDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 01/23/2016 13:33'!
createInstanceOn: aBpmProcessInstance
	"The receiver create a concrete instance of it self.
	If it is Splitting --> create the instance.
	If it is Merging --> check if there is a running gateway of it self if not then create the instance"

	self isSplitting 
	ifTrue: [^self createNewGatewayOn: aBpmProcessInstance].

	"--> isMerging"

	^(aBpmProcessInstance hasRunningGatewayNamed: name)
	ifTrue: [aBpmProcessInstance getRunningGatewayNamed: name]
	ifFalse: [self createNewGatewayOn: aBpmProcessInstance].! !

!BpmInclusiveGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/23/2015 13:38'!
initialize

	super initialize.

	waitAllIncoming := true. "whether or not wait for processing until all incoming transition are done"! !

!BpmInclusiveGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:40'!
instanceClass

	^BpmInclusiveGateway! !

BpmGatewayDefinition subclass: #BpmParallelEventBasedGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmParallelEventBasedGatewayDefinition commentStamp: 'BrunoBB 11/23/2015 13:33' prior: 0!
As the name suggest, this gateway is similar to a parallel gateway. It allows for multiple processes to happen at the same time, but unlike the parallel gateway, the processes are event dependent.!

!BpmParallelEventBasedGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:35'!
instanceClass

	^self subclassResponsibility! !

BpmGatewayDefinition subclass: #BpmParallelGatewayDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmParallelGatewayDefinition commentStamp: 'BrunoBB 11/23/2015 13:33' prior: 0!
(+)
A parallel gateway is very different than the previous gateways because you aren't evaluating any condition or event. Instead, parallel gateways are used to represent two concurrent tasks in a business flow.

Splitting: the flow will go down all the paths originated in the Gateway. 

Merging: it synchronizes all the paths that arrive to the Gateway!

!BpmParallelGatewayDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 01/23/2016 13:38'!
createInstanceOn: aBpmProcessInstance
	"The receiver create a concrete instance of it self.
	If it is Splitting --> create the instance.
	If it is Merging --> check if there is a running gateway of it self if not then create the instance"

	self isSplitting 
	ifTrue: [^self createNewGatewayOn: aBpmProcessInstance].

	"--> isMerging"

	^(aBpmProcessInstance hasRunningGatewayNamed: name)
	ifTrue: [aBpmProcessInstance getRunningGatewayNamed: name]
	ifFalse: [self createNewGatewayOn: aBpmProcessInstance].! !

!BpmParallelGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/23/2015 13:39'!
initialize

	super initialize.

	waitAllIncoming := true. "whether or not wait for processing until all incoming transition are done"! !

!BpmParallelGatewayDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:38'!
instanceClass

	^BpmParallelGateway! !

!BpmArtifactDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 15:41'!
process: aBpmProcessDefinition

	^super new initialize
		processDefinition: aBpmProcessDefinition;
		yourself! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 12:23'!
addInTransition: aBpmTransitionDefinition

	^inTransitions add: aBpmTransitionDefinition! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 12:23'!
addOutTransition: aBpmTransitionDefinition

	^outTransitions add: aBpmTransitionDefinition! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:21'!
addToParentProcess

	^self subclassResponsibility! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 10:47'!
applicationName

	^processDefinition applicationName! !

!BpmArtifactDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 11/23/2015 08:47'!
createInstanceOn: aBpmProcessInstance

	^(self instanceClass definition: self)
		process: aBpmProcessInstance;
		yourself! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/13/2015 13:37'!
extendedAttributes
	^extendedAttributes! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 13:37'!
extendedAttributes: newValue
	extendedAttributes := newValue! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:38'!
extendedValueOf: attrName

	^extendedAttributes at: attrName ifAbsent: [nil]! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:38'!
extendedValueOf: attrName ifAbsent: aBlock

	^extendedAttributes at: attrName ifAbsent: aBlock! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 09:28'!
grantRole: aBpmRole

	aBpmRole addResponsibility: self.

	^roles add: aBpmRole! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 04/13/2016 10:17'!
hasPerformers
	"Answer whether or not the receiver has performers.
	Regular task consist in one form or one Seaside Component.
	Task with performers enable to more than one role work in the same task (in sequential way)"

	^false! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:37'!
initialize

	super initialize.

	inTransitions := OrderedCollection new.
	outTransitions := OrderedCollection new.
	roles := OrderedCollection new.

	extendedAttributes := Dictionary new.! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:34'!
instanceClass

	^self subclassResponsibility! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/28/2015 11:57'!
inTransitions
	^inTransitions! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 11:57'!
inTransitions: newValue
	inTransitions := newValue! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 15:10'!
isEndEvent

	^false! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 05:54'!
isGrantedRole: aBpmRole

	^roles includes: aBpmRole! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/30/2015 06:33'!
isGrantedRoleNamed: aString

	^roles anySatisfy: [:each | each name = aString]! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 11/22/2015 15:49'!
isGrantedUser: aBpmUser
	"Answer whether or not the user <aBpmUser> is granted in the receiver"

	^roles anySatisfy: [:each | each isGranted: aBpmUser]! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/28/2015 09:08'!
isMultiInstance

	^false! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 15:50'!
isOrbeonTask

	^false! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 06:43'!
isSubprocessDefinition

	^false! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 10:51'!
isTaskDefinition

	^false! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 16:14'!
name
	^name! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 16:14'!
name: newValue
	name := newValue! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/28/2015 11:57'!
outTransitions
	^outTransitions! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 11:57'!
outTransitions: newValue
	outTransitions := newValue! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 01/16/2016 15:06'!
performers

	^#()! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:16'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: ' (', self printOnType, ') [', name, ']'.! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:13'!
printOnType

	^'Art'! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 10:49'!
printRoleNames
	| names |

	names := ''.
	roles do: [:each | names := names, each name, '; ' ].

	^names! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 16:14'!
processDefinition
	^processDefinition! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 16:14'!
processDefinition: newValue
	processDefinition := newValue! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 10:48'!
processDefinitionName

	^processDefinition processName! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:38'!
removeExtendedAttribute: attrName 

	^extendedAttributes removeKey: attrName ifAbsent: []! !

!BpmArtifactDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:22'!
roles
	^roles! !

!BpmArtifactDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:22'!
roles: newValue
	roles := newValue! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 04/09/2016 12:55'!
setExtendedAttribute: attrName value: anObject

	^extendedAttributes at: attrName put: anObject! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 02/18/2016 12:02'!
taskName

	^name! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 02/19/2016 13:10'!
ungrantAllRoles
		"The receiver ungrant all roles "

		roles do: [:each | each removeResponsibility: self].

		roles := OrderedCollection new.! !

!BpmArtifactDefinition methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 10:21'!
ungrantRole: aBpmRole

	aBpmRole removeResponsibility: self.

	^roles remove: aBpmRole 
				ifAbsent: [NoSuchRoleException signal: 'The receiver has no such a role name [', aBpmRole name, ']']! !

BpmArtifactDefinition subclass: #BpmEventDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmEventDefinition subclass: #BpmEndEventDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmEndEventDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:26'!
addToParentProcess

	^processDefinition addEndEvent: self! !

!BpmEndEventDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:35'!
instanceClass

	^BpmEndEventInstance! !

!BpmEndEventDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 15:10'!
isEndEvent

	^true! !

!BpmEndEventDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:14'!
printOnType

	^'ev:end'! !

BpmEventDefinition subclass: #BpmIntermediateEventDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmIntermediateEventDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:26'!
addToParentProcess

	^processDefinition addIntermediateEvent: self! !

!BpmIntermediateEventDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:36'!
instanceClass

	^BpmIntermediateEventInstance! !

!BpmIntermediateEventDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:14'!
printOnType

	^'ev:in'! !

BpmEventDefinition subclass: #BpmStartEventDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmStartEventDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:26'!
addToParentProcess

	^processDefinition startEvent: self! !

!BpmStartEventDefinition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:35'!
instanceClass

	^BpmStartEventInstance! !

!BpmStartEventDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:14'!
printOnType

	^'ev:start'! !

BpmObject subclass: #BpmCodeAnalyzer
	instanceVariableNames: 'blockCode codeWarnings parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmCodeAnalyzer class methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:33'!
example1
	"
BpmCodeAnalyzer example1
"
	^(super new blockCode: '[:form | MyClass resetAll. form class removeAll]')
		analyze
		codeWarnings.! !

!BpmCodeAnalyzer class methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:33'!
example2
	"
BpmCodeAnalyzer example2
"
	^(super new blockCode: '[:form | form age > 10 and:[form amount = 3 or:[form type = ''28'']]. Compiler compile: ''lajdflasj'']')
		analyze
		codeWarnings.! !

!BpmCodeAnalyzer class methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:30'!
for: blockCode

	^super new initialize
		blockCode: blockCode;
		yourself! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:31'!
addBlockWarning: aString

	^codeWarnings add: aString! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 04/08/2016 10:34'!
analyze

	parser isBlock ifFalse: [^self addBlockWarning: 'Condition is NOT a Block'; yourself].

	self checkOneArgumentBlockRule; "check the block has only one argument"
		checkReceiverVariableRule; "check that all receivers are the block argument or a basic class (Date, Time, TimeStamp)"
		checkReceiverVariableMessagesRule! !

!BpmCodeAnalyzer methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 10:31'!
blockCode
	^blockCode! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:36'!
blockCode: newValue

	blockCode := newValue.
	parser := [RBParser parseExpression: blockCode] on: Error do: [:err | self addBlockWarning: err description].! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:31'!
checkOneArgumentBlockRule
	"Receiver's block must be a ONE argument block"

	(parser arguments size = 0) 
	ifTrue: [^self addBlockWarning: 'Block has no argument'].

	(parser arguments size > 1) 
	ifTrue: [^self addBlockWarning: 'Block has more than one argument'].! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 15:16'!
checkReceiverVariableMessagesRule
	"All messages sent to Block's argument MUST be NOT understand by <BpmProcessInstance> and <OrbeonFormInstance>.
	Inside the block messages are sent only to fields of <OrbeonFormInstance> or <BpmProcessInstance> and this messages are dispatched using #doesNotUnderstand:. 
	So inside the block message to the argument MUST fail "
	| atomicMessages notPerfomMessages perfomMessages |

	"<atomicMessages> MUST have the receiver equal to Block argument"
	atomicMessages := parser allChildren select: [:each | each isMessage and: [each receiver isVariable]].

	notPerfomMessages := atomicMessages reject: [:each | each selector = #perform:].
	perfomMessages := atomicMessages select: [:each | each selector = #perform:].

	(notPerfomMessages select: [:each | (self getOrbeonFormInstanceClassOrNil ifNotNil: [:value | value canUnderstand: each selector] ifNil: [false])
													or: [BpmProcessInstance canUnderstand: each selector]]) 
		do: [:each | self addBlockWarning: 'Valid message [', each selector,'] is sent to Form or Process.'].

	"Check form #perform: with more that one argument, NOT allowed only a string with a field name is allowed for message #perform: "
	(perfomMessages select: [:each | each arguments size > 1]) do: [:each | self addBlockWarning: 'Perform message sent with more than one argument.'].

	"Check for suspicious string as argument of #perform: message, more than one string (subString: space) as argument of #perform: NOT allowed"
	(perfomMessages select: [:each | (each arguments size = 1) and: [each arguments last token isLiteralToken and: [(each arguments last value subStrings: ' ') size > 1]]]) do: [:each | self addBlockWarning: 'Suspicious string inside #perform: message']! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 04/08/2016 11:35'!
checkReceiverVariableRule
	"All basic receivers (receiver isVariable) MUST send message only to Block argument.
	If a message is sent to a <variable receiver> and this <variable receiver> is not the block argument then it can be malicious code or an error"
	| atomicMessages argumentName |

	"<atomicMessages> MUST have the receiver equal to Block argument"
	atomicMessages := parser allChildren select: [:each | each isMessage and: [each receiver isVariable]].

	(parser arguments size = 1) ifFalse: [^self]."if arguments size is not correct --> we abort the following checks"

	argumentName := parser arguments last name. "the name of the Block argument (each or whatever)"

	(atomicMessages select: [:each | 
			(each receiver name ~= argumentName) 
			and:[(self getBasicClasses includes: each receiver name) not 
					or:[each selector ~= #fromString:]]]) 
	do: [:each | self addBlockWarning: 'Message is sent to object [', each receiver name, '] that is NOT the argument of the Block or it is a forbidden message [', each selector, '].' ]! !

!BpmCodeAnalyzer methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 10:31'!
codeWarnings
	^codeWarnings! !

!BpmCodeAnalyzer methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 10:31'!
codeWarnings: newValue
	codeWarnings := newValue! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 04/08/2016 10:59'!
getBasicClasses

	^#('Date' 'Time' 'TimeStamp')! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 15:14'!
getOrbeonFormInstanceClassOrNil
	"This method is implemented in this way to make BPM package independent of the Orbeon package"

	^Smalltalk at: #OrbeonFormInstance ifAbsent: [nil]! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:32'!
hasWarinings

	^codeWarnings notEmpty! !

!BpmCodeAnalyzer methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 10:32'!
initialize

	super initialize.
	
	codeWarnings := OrderedCollection new.! !

!BpmCodeAnalyzer methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 10:31'!
parser
	^parser! !

!BpmCodeAnalyzer methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 10:31'!
parser: newValue
	parser := newValue! !

BpmObject subclass: #BpmCodeCondition
	instanceVariableNames: 'evaluationCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmCodeCondition class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 13:10'!
code: aString

	^super new initialize
		evaluationCode: aString;
		yourself! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 11/25/2015 10:46'!
evaluateConditionIn: aBpmProcessInstance
	"The receiver evaluates the condition <conditionToRun> in the context of the object <aBpmProcessInstance>"
	| evaluation blockClosure blockEvaluation |

	evaluation := BpmCodeEvaluationResult new.

	[ 	blockClosure := self evaluate: evaluationCode. "aBlockClosure instance is created"
		blockEvaluation := blockClosure value: aBpmProcessInstance.
		evaluation result: blockEvaluation] on: Error do:[:error | evaluation exception: error].

	"evaluation does not raised anException but the result is NOT a boolean value"
	(evaluation hasNoException and: [evaluation resultNotBoolean]) 
	ifTrue: [evaluation exception: EvaluationNotBooleanException new].

	"the variable <blockClosure> MUST BE a BlockClosure because the <condition> could be a valid Smalltalk expression but NOT a block"
	blockClosure isBlock
	ifFalse: [evaluation exception: EvaluationNotBlockException new].

	^evaluation! !

!BpmCodeCondition methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 13:10'!
evaluationCode
	^evaluationCode! !

!BpmCodeCondition methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 13:10'!
evaluationCode: newValue
	evaluationCode := newValue! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 07:00'!
hasEvaluation

	^evaluationCode notNil and: [evaluationCode notEmpty]! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 04/19/2016 16:18'!
hasEvaluationConditionWithFieldNamed: fieldName
	"Answer whether or not the field named <fieldName> is included in the evaluation expression of the receiver"
	| parser messagesToProcess |

	evaluationCode ifNil: [^false].

	parser := RBParser parseExpression: evaluationCode.

	messagesToProcess := parser allChildren select: [:each | each isMessage and:[each receiver isVariable]].

	^messagesToProcess anySatisfy: [:each | each selector asString = fieldName asString]! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:30'!
printEvaluationCode

	evaluationCode ifNil: [^'none'].

	^evaluationCode! !

!BpmCodeCondition methodsFor: 'other' stamp: 'BrunoBB 11/13/2015 10:27'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '{', self printEvaluationCode, '}'! !

!BpmObject methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 06:18'!
getProcessDefinitionCache

	^BpmProcessDefinition cache! !

!BpmObject methodsFor: 'exceptions' stamp: 'BrunoBB 12/04/2015 10:36'!
throwExceptionTaskAssignmentNotFound

	^NoSuchTaskAssignmentException signal: 'The BpmTaskAssignment was not found in the tasks collection'! !

!BpmObject methodsFor: 'exceptions' stamp: 'BrunoBB 12/05/2015 13:57'!
throwNoProcessMatrixExceptionFor: processName

	^NoProcessMatrixException signal: 'No Matrix has been created for process named [', processName, ']'! !

BpmObject subclass: #BpmParticipantDefinition
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmParticipantDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 15:45'!
name
	^name! !

!BpmParticipantDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 15:45'!
name: newValue
	name := newValue! !

!BpmParticipantDefinition methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 16:32'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[',name, ']'.! !

BpmParticipantDefinition subclass: #BpmResourceParticipantDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmParticipantDefinition subclass: #BpmRoleParticipantDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmObject subclass: #BpmProcessDefinition
	instanceVariableNames: 'id processName sheetName executionPath roles processInstances application version subProcesses formFieldInstances participants xmlString'
	classVariableNames: 'AnonymousFormMapping Cache'
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmProcessDefinition commentStamp: '' prior: 0!
id 								- id of the process definition
processName 				- name of the process definition
sheetName					- name of the sheet as is in Bizagi modeler
executionPath 			- the execution path of the receiver
roles 							- unused
processInstances 		- all instances of the receiver (BpmProcessInstance)
application	                - application where the process definition is defined (where the definiton belong)
version 						- version of the definition
subProcesses 				- defined sub process of the receiver
formFieldInstances 		- a dictionary of dictionaries to store in one collection all instances of particular field (one collection for each field name)
participants					- additional roles of the receiver
xmlString						- XPDL string of the receiver!

!BpmProcessDefinition class methodsFor: 'anonymous mapping' stamp: 'BrunoBB 03/30/2016 10:48'!
anonymousFormMapping

	AnonymousFormMapping ifNil: [AnonymousFormMapping := Dictionary new].

	^AnonymousFormMapping! !

!BpmProcessDefinition class methodsFor: 'cache' stamp: 'BrunoBB 10/31/2015 09:23'!
cache

	Cache ifNil: [Cache := Dictionary new].

	^Cache! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 03/26/2016 15:39'!
getAllProcessesNamed: aString in: appName
	"Answer a collection with all versions of process named <aString> in the Application named <appName>"

	^((self cache at: appName ifAbsent: [^#()])
			at: aString ifAbsent: [^#()])! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 03/26/2016 15:57'!
getAllVersionsIn: appName
	"Answer a collection with all processes and all processes versions in Application named <appName>"
	| all |

	all := OrderedCollection new.
	(self cache at: appName ifAbsent: [^all]) do: [:procVersions | all addAll: procVersions].

	^all! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 03/26/2016 15:35'!
getAssignmentsIn: appName processName: processNamed formName: formNamed fieldName: fieldNamed initialValue: intialValue endValue: endValue
	"The receiver answer a collection of <OrbeonProcessAssignment> in application named <appName>  for process type <processNamed> where the field named <fieldNamed> is equal to <fieldValue>"
	| procDefinition |

	procDefinition := self getAllProcessesNamed: processNamed in: appName.
	procDefinition ifEmpty: [^#()].

	procDefinition := procDefinition last.

	^procDefinition getFieldsNamed: fieldNamed in: formNamed initialValue: intialValue endValue: endValue! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 03/26/2016 15:36'!
getAssignmentsIn: appName processName: processNamed formName: formNamed fieldName: fieldNamed withValue: fieldValue
	"The receiver answer a collection of <OrbeonProcessAssignment> in application named <appName>  for process type <processNamed> where the field named <fieldNamed> is equal to <fieldValue>"
	| procDefinition |

	procDefinition := self getAllProcessesNamed: processNamed in: appName.
	procDefinition ifEmpty: [^#()].

	procDefinition := procDefinition last.

	^procDefinition getFieldsNamed: fieldNamed  in: formNamed withValue: fieldValue! !

!BpmProcessDefinition class methodsFor: 'anonymous mapping' stamp: 'BrunoBB 03/31/2016 16:10'!
getBpmProcessDefinitionForForm: formName in: appName
	"The receiver answer a <BpmProcessDefinition> associated with the Form <formName> in Application <appName>. If none is associated raise an Exception.
	This process can have an anonymous starter/user (nil)"

	^self anonymousFormMapping 
		at: (appName, '.', formName)
		ifAbsent: [^FormToProcessDefinitionMappingException signal: 'There is NO BpmProcessDefinition mapped to form [', formName, '] in Application [', appName, ']']! !

!BpmProcessDefinition class methodsFor: 'query' stamp: 'BrunoBB 02/29/2016 09:25'!
hasAnyProcessApplicationNamed: aString
	"Answer whether or not the Application named <aString> has any BpmProcessDefinition"

	^(self cache includesKey: aString) and: [(self cache at: aString) notEmpty]! !

!BpmProcessDefinition class methodsFor: 'anonymous mapping' stamp: 'BrunoBB 03/30/2016 10:45'!
initializeAnonymousFormMapping

	AnonymousFormMapping := Dictionary new! !

!BpmProcessDefinition class methodsFor: 'cache' stamp: 'BrunoBB 10/31/2015 09:23'!
initializeCache

	Cache := Dictionary new! !

!BpmProcessDefinition class methodsFor: 'cache' stamp: 'BrunoBB 10/27/2015 15:28'!
newNamed: aString

	^super new initialize
		processName: aString;
		yourself! !

!BpmProcessDefinition class methodsFor: 'anonymous mapping' stamp: 'BrunoBB 03/30/2016 16:12'!
registerAnonymousMappingForm: formName in: appName for: aBpmProcessDefinition

	^self anonymousFormMapping at: (appName, '.', formName) put: aBpmProcessDefinition! !

!BpmProcessDefinition class methodsFor: 'cache' stamp: 'BrunoBB 12/10/2015 10:02'!
removeAllDefinitions

	self cache do: [:eachDictionary | 
		eachDictionary do: [:procCollection | 
			procCollection do: [:eachProc | 
				eachProc getAllArtifacts do: [:eachArt | eachArt ungrantAllRoles]. "remove tasks from roles"
			].
		].
	].

	^self initializeCache! !

!BpmProcessDefinition class methodsFor: 'cache' stamp: 'BrunoBB 12/12/2015 11:13'!
removeAllFormFieldInstances

	self cache do: [:eachDictionary | 
		eachDictionary do: [:procCollection | 
			procCollection do: [:eachProc | 
				eachProc formFieldInstances: Dictionary new. "remove all form field instances"
			].
		].
	].! !

!BpmProcessDefinition class methodsFor: 'anonymous mapping' stamp: 'BrunoBB 03/30/2016 16:08'!
unregisterAnonymousMappingFor: formName in: appName

	^self anonymousFormMapping removeKey: (appName, '.', formName) ifAbsent: []! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 11/28/2015 19:55'!
addAllParticipants: aCollection
	"The receiver add all participants <BpmParticipantDefinition> in the collection <aCollection>"

	^aCollection do: [:bpmParticipant | participants at: bpmParticipant name put: bpmParticipant]! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 11/28/2015 19:56'!
addEndEvent: aBpmEndEventDefinition
	"The receiver add the event definition <aBpmEndEventDefinition>"

	^executionPath addEndEvent: aBpmEndEventDefinition! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 11/28/2015 19:56'!
addGateway: aBpmGatewayDefinition
	"The receiver add the gateway definition <aBpmGatewayDefinition>"

	^executionPath addGateway: aBpmGatewayDefinition! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 11/28/2015 19:56'!
addIntermediateEvent: aBpmIntermediateEventDefinition
	"The receiver add the intermediate definition <aBpmIntermediateEventDefinition>"

	^executionPath addIntermediateEvent: aBpmIntermediateEventDefinition! !

!BpmProcessDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 11/28/2015 19:59'!
addProcessInstance: aBpmProcessInstance
	"The receiver add the process instance <aBpmProcessInstance> to it's collection"

	^processInstances at: aBpmProcessInstance id put: aBpmProcessInstance! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 05:56'!
addSubProcess: aBpmSubProcessDefinition
	"The receiver add the subprocess <aBpmSubProcessDefinition> to it's sub process collection. Set the receiver as the parent process of the process argument <aBpmSubProcessDefinition>"

	aBpmSubProcessDefinition parentProcess: self.

	^subProcesses at: aBpmSubProcessDefinition processName put: aBpmSubProcessDefinition! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 11/28/2015 19:57'!
addSubProcessTask: aBpmSubProcessTaskDefinition
	"The receiver add the subprocess task definition <aBpmSubProcessTaskDefinition>"

	^executionPath addSubProcessTask: aBpmSubProcessTaskDefinition! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 11/28/2015 19:57'!
addTask: aBpmTaskDefinition
	"The receiver add the task definition <aBpmTaskDefinition>"

	^executionPath addTask: aBpmTaskDefinition! !

!BpmProcessDefinition methodsFor: 'fields update' stamp: 'BrunoBB 04/20/2016 17:01'!
addTo: formNamed fieldValue: anAppFieldValue
	"The receiver add to Orbeon form named <formNamed> the field value <anAppFieldValue>.
	The receiver holds a Dictionary with all form's name. Each form's name Dictionary is a Dictionary of fields's name. The value at a given field's name is anUnorderedCollection.
	(formName)>>(fieldName)>>(anUnorderedCollection)"
	| fieldsDictionary fieldCollection |

	fieldsDictionary := (formFieldInstances includesKey: formNamed) 
		ifTrue: [formFieldInstances at: formNamed]
		ifFalse: [formFieldInstances at: formNamed put: Dictionary new].

	fieldCollection := (fieldsDictionary includesKey: anAppFieldValue getKeyName)
		ifTrue: [fieldsDictionary at: anAppFieldValue getKeyName]
		ifFalse: [| indexedCollection |
			indexedCollection := RcIdentityBag new.
			fieldsDictionary at: anAppFieldValue getKeyName put: indexedCollection.
			indexedCollection add: anAppFieldValue.
			"indexes can NOT be created on empty collections so we add the element first"
			self createFieldIndexFor: anAppFieldValue in: formNamed on: indexedCollection.
			^anAppFieldValue].

	^fieldCollection add: anAppFieldValue! !

!BpmProcessDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 17:59'!
addToAnonymousStart

	^self class anonymousFormMapping at: self getAnonymousFormName put: self! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 14:44'!
addToCache
	"Add the receiver to the global cache for this class"
	| processesDictionary processDefinitions |

	(processName isNil or:[processName isEmpty]) ifTrue: [^NoProcessNameException signal: 'ProcessDefinition MUST have a name'].
	application ifNil: [^NoApplicationException signal: 'ProcessDefinition MUST have anOrbeonApplication'].

	processesDictionary := (self class cache includesKey: application applicationName) "get the dictionary of processes"
			ifTrue: [self class cache at: application applicationName]
			ifFalse: [self class cache at: application applicationName put: Dictionary new].

	processDefinitions := (processesDictionary includesKey: processName) "get the collection of versions for definition named <processName>"
			ifTrue: [processesDictionary at: processName] 
			ifFalse: [processesDictionary at: processName put: OrderedCollection new].

	processDefinitions isEmpty 
	ifFalse: [version := processDefinitions last version + 1]
	ifTrue: [version := 1].

	processDefinitions add: self.! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 11/28/2015 19:57'!
addTransition: aBpmTransitionDefinition
	"The receiver add the transition definition <aBpmTransitionDefinition>"

	^executionPath addTransition: aBpmTransitionDefinition! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/27/2015 12:21'!
application
	^application! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/27/2015 12:21'!
application: newValue
	application := newValue! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 14:45'!
applicationName

	^application applicationName! !

!BpmProcessDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 17:30'!
canBeStartedByAnonymousForm
	"Answer whether or not the BpmProcessDefinition can be start by sending an anonymous form"

	^false! !

!BpmProcessDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 11/22/2015 15:50'!
canCreateProcessInstance: aBpmUser
	"Answer whether or not the user <aBpmUser> can create a process instance of the receiver"

	^executionPath canCreateProcess: aBpmUser! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 03/26/2016 15:35'!
canDelete
	"Answer whether or not the receiver can be deleted from the system"

	^formFieldInstances isEmpty 
		and: [(self class getAllProcessesNamed: processName in: self applicationName) size = version] 
				"this is to preserve the version number chain unbroken - (only the latest version can be removed)"! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 06:51'!
canModifyPathDefinition

	^false! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 04/14/2016 14:28'!
clone
	"The receiver is cloned with a new version number"
	| xpdlReader processGenerator |

	xpdlReader := XPDLReader2 for: processName withString: xmlString.

	subProcesses do: [:each | xpdlReader addXPDLDocument:  (XMLDOMParser parse: each xmlString) namedAs: each processName].

	xpdlReader connectProcesses.

	processGenerator :=  BpmProcessGenerator on: xpdlReader xpdlPackages.

	processGenerator mapProcess: processName toApplication: application.

	subProcesses do: [:each | processGenerator mapProcess: each processName toApplication: each application].

	processGenerator generateAllProcess.

	"processGenerator processes do: [:each | each addToCache]."

	^processGenerator processes! !

!BpmProcessDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 03/30/2016 16:48'!
createAndStartProcessInstance: aBpmUser
	"Create a new process instance based on the receiver if the user <aBpmUser> does not have creation permission throw an exception.
	The new process can be a main process or a subprocess <BpmMainProcessInstance> <BpmSubProcessInstance>"

	^(self createProcessInstance: aBpmUser)
		triggerStartEventWith: aBpmUser;
		yourself! !

!BpmProcessDefinition methodsFor: 'fields update' stamp: 'BrunoBB 04/20/2016 16:40'!
createFieldIndexFor: anAppFieldValue in: formNamed on: indexedCollection
	"Create a collection (RcIdentityBag) that hold indexes for the field values of <anAppFieldValue> in the form <formNamed>"
	| objectDefinition |

	"get the definition of the parent object (aOrbeonFormDefinition or a BpmSeasideIntegrationObject)"
	objectDefinition := anAppFieldValue parentObject definition. 

	^objectDefinition createFieldIndexFor: anAppFieldValue on: indexedCollection! !

!BpmProcessDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 03/26/2016 14:33'!
createProcessInstance: aBpmUser
	"Create a new process instance based on the receiver if the user <aBpmUser> does not have creation permission throw an exception.
	The new process can be a main process or a subprocess <BpmMainProcessInstance> <BpmSubProcessInstance>"
	| newProcess |

	(self canCreateProcessInstance: aBpmUser) ifFalse: [^self throwNoCreationPermissionExceptionFor: aBpmUser username].

	newProcess := self getProcessInstanceClass definition: self user: aBpmUser.

	self addProcessInstance: newProcess. "add the new process instance dictionary"

	^newProcess! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/26/2015 18:39'!
executionPath
	^executionPath! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/26/2015 18:39'!
executionPath: newValue
	executionPath := newValue! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
formFieldInstances
	^formFieldInstances! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
formFieldInstances: newValue
	formFieldInstances := newValue! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 12/10/2015 09:59'!
getAllArtifacts
	"The receiver answer a collection with all artifacts <aBpmArtifactDefinition>"

	^executionPath getAllArtifacts! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 09:49'!
getAllRoles
	"Answer a collection with all <BpmRole> that perform at least one task in the receiver"

	^executionPath getAllRoles! !

!BpmProcessDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 17:43'!
getAnonymousFormName
	"Answer the name of the anonymous form"

	^executionPath getAnonymousFormName! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 02/08/2016 14:45'!
getApplicationName

	^application applicationName! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 03/11/2016 13:00'!
getApplicationNameForCombo

	^application getApplicationNameForCombo! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:49'!
getEndEventNamed: aString ifNone: aBlock
	"The receiver answer the end event <BpmEndEventDefinition> named <aString> if such event does not exist evaluate <aBlock> "

	^executionPath getEndEventNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'search' stamp: 'BrunoBB 02/22/2016 12:58'!
getFieldsNamed: fieldNamed in: formNamed initialValue: intialValue endValue: endValue
	"The receiver answer a collection of <OrbeonProcessAssignment>s with field named <fieldNamed> in form named <formNamed> where the value of the object is greater thatn <intialValue> and less than <endValue>"
	| taskDefinition formDictionary fieldRcUnCollection stType stValue stValue2 |

	"we get the actual definition because the OrbeonForms and SeasideModel use different name convention, see #getObjectName #taskName"
	taskDefinition := self getTaskNamed: formNamed ifNone: [^#()].

	formDictionary := formFieldInstances at: taskDefinition taskName ifAbsent: [^#()].
	fieldRcUnCollection := formDictionary at: fieldNamed ifAbsent: [^#()].

	stType := taskDefinition getObjectModel stTypeOf: fieldNamed.
	stValue := [stType fromString: intialValue] on: Error do: [:err | ^#()].
	stValue2 := [stType fromString: endValue] on: Error do: [:err | ^#()].

	^((GsQuery fromString: ('(each.value >= intialValue) & (each.value <= endValue)') on: fieldRcUnCollection) 
		bind: 'intialValue' to: stValue; 
		bind: 'endValue' to: stValue2; 
		queryResult) collect: [:each | each getAssignment]! !

!BpmProcessDefinition methodsFor: 'search' stamp: 'BrunoBB 03/31/2016 17:40'!
getFieldsNamed: fieldNamed in: formNamed withValue: fieldValue
	"The receiver answer a collection of <OrbeonProcessAssignment>s with field named <fieldNamed> with value <fieldValue> in form <formNamed>"
	| taskDefinition formDictionary fieldRcUnCollection stType stValue |

	"we get the actual definition because the OrbeonForms and SeasideModel use different name convention, see #getObjectName #taskName"
	taskDefinition := self getTaskNamed: formNamed ifNone: [^#()].

	formDictionary := formFieldInstances at: taskDefinition taskName ifAbsent: [^#()].
	fieldRcUnCollection := formDictionary at: fieldNamed ifAbsent: [^#()].

	stType := taskDefinition getObjectModel stTypeOf: fieldNamed.
	stValue := [stType fromString: fieldValue] on: Error do: [:err | ^#()].

	^((GsQuery fromString: ('each.value = stValue') on: fieldRcUnCollection) 
		bind: 'stValue' to: stValue; 
		queryResult) collect: [:each | each getAssignment]! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 02/23/2016 14:13'!
getFormDefinitionNamed: formName ifNone: aBlock
	"The receiver answer a form definition <OrbeonFormDefinition> named <endFormName>.
	If the form does not exist evaluate the zero argument block <aBlock>"
	| taskDefinition |

	taskDefinition := self getTasks detect: [:each | each name = formName] ifNone: [^aBlock value].

	^taskDefinition getObjectModel! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:50'!
getGatewayNamed: aString ifNone: aBlock
	"The receiver answer the gateway <BpmGatewayDefinition> named <aString> if such gateway does not exist evaluate <aBlock> "

	^executionPath getGatewayNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:50'!
getIntermediateEventNamed: aString ifNone: aBlock
	"The receiver answer the intermediate event <BpmIntermediateEventDefinition> named <aString> if such event does not exist evaluate <aBlock> "

	^executionPath getIntermediateEventNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:03'!
getNumberOfEndEvents

	^executionPath getNumberOfEndEvents! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:03'!
getNumberOfGateways

	^executionPath getNumberOfGateways! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:04'!
getNumberOfIntermediateEvents

	^executionPath getNumberOfIntermediateEvents! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:04'!
getNumberOfSubProcessTasks

	^executionPath getNumberOfSubProcessTasks! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:04'!
getNumberOfTasks

	^executionPath getNumberOfTasks! !

!BpmProcessDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:04'!
getNumberOfTransitions

	^executionPath getNumberOfTransitions! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/16/2015 13:09'!
getOrderedTasks

	^executionPath getOrderedTasks! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 03/06/2016 17:46'!
getOrderedTasksNames

	^executionPath getOrderedTasks collect: [:each | each name]! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 06:48'!
getParentProcessName

	^self subclassResponsibility! !

!BpmProcessDefinition methodsFor: 'running' stamp: 'BrunoBB 04/10/2016 18:49'!
getProcessesTreeAsCollection
	"Answer a collection with all process in the tree process structure (parentProcesses and subprocesses)"

	^self getProcessTree: OrderedCollection new! !

!BpmProcessDefinition methodsFor: 'running' stamp: 'BrunoBB 04/10/2016 18:49'!
getProcessTree: anOrderedCollection
	"Answer a collection with all process in the tree process structure (parentProcesses and subprocesses)"

	self subclassResponsibility! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:51'!
getSubProcessDefinitions
	"Answer a collection with all receiver's subprocesses <BpmProcessDefinition>"

	^self getSubProcessTasks collect: [:each | each subProcessDefinition]! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:51'!
getSubProcessTaskNamed: aString ifNone: aBlock
	"The receiver answer the subprocess <BpmProcessDefinition> named <aString> if such subprocess does not exist evaluate <aBlock> "

	^executionPath getSubProcessTaskNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:52'!
getSubProcessTasks
	"Answer a collection with all receiver's subprocesses tasks <BpmSubProcessTaskDefinition>"

	^executionPath subProcessTasks! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:53'!
getTaskNamed: aString ifNone: aBlock
	"The receiver answer the task <BpmTaskDefinition> named <aString> if such task does not exist evaluate <aBlock> "

	^executionPath getTaskNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 02/18/2016 12:15'!
getTaskNames
	"The receiver answer a collection with all names of it's tasks <aBpmTaskDefinition>"

	^self getTasks collect: [:each | each name]! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 12/10/2015 06:36'!
getTasks
	"The receiver answer a collection with all of it's tasks <aBpmTaskDefinition>"

	^executionPath tasks! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 11/28/2015 19:53'!
getTransitionNamed: aString ifNone: aBlock
	"The receiver answer the transition <BpmTransitionDefinition> named <aString> if such transition does not exist evaluate <aBlock> "

	^executionPath getTransitionNamed: aString ifNone: aBlock! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 06:52'!
getTransitions

	^executionPath transitions! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 02/19/2016 13:38'!
getTypeOf: fieldNamed in: formName ifNone: aBlock
	"The receiver answer the type of the field named <fieldNamed> in the form definition named <formName>.
	If the form is not found then evaluate the zero argument block <aBlock>"
	| taskDefinition |

	taskDefinition := self getTaskNamed: formName ifNone: [^aBlock value].

	^taskDefinition getObjectModel stTypeOf: fieldNamed! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 06:51'!
hasFinishedProcesses

	^processInstances notEmpty! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 04/19/2016 15:06'!
hasGatewayConditionIncludingFieldNamed: fieldName
	"Answer whether or not the receiver has a <BpmGatewayDefinition> with condition that includes a field named <fieldName>"

	^executionPath hasGatewayConditionIncludingFieldNamed: fieldName! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 01/23/2016 07:26'!
hasOrbeonFormNamed: aString
	"The receiver answer whether or not it hold a form <OrbeonFormDefinition> named <aString>"

	^executionPath hasOrbeonFormNamed: aString! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 04/15/2016 10:13'!
hasSubProcesses

	^subProcesses notEmpty! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 12/21/2015 09:45'!
hasTaskNamed: aString

	^executionPath hasTaskNamed: aString! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/26/2015 18:31'!
id
	^id! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/26/2015 18:31'!
id: newValue
	id := newValue! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 03/26/2016 14:36'!
initialize

	super initialize.

	id := Lag1MwcRandom new integer.
	executionPath := BpmProcessPathDefinition definition: self.
	roles := Dictionary new.
	participants := Dictionary new.
	version := 1.
	subProcesses := Dictionary new.
	processInstances := RcKeyValueDictionary new.
	formFieldInstances := Dictionary new.! !

!BpmProcessDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 17:59'!
isAnonymousStartEnabled

	^self class anonymousFormMapping includesKey: self getAnonymousFormName! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 17:18'!
isSubProcess

	^false! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 17:17'!
isTopProcess

	^false! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 17:18'!
parentProcess

	^self subclassResponsibility! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 15:45'!
participants
	^participants! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 15:45'!
participants: newValue
	participants := newValue! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:41'!
printArtifacts

	^executionPath printArtifacts! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 03/26/2016 15:52'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[', processName, ' v.', version printString, ']'! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/12/2015 13:03'!
printParentName

	^self parentProcess ifNil: ['-'] ifNotNil: [:value | value processName]! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:32'!
printTransitions

	^executionPath printTransitions! !

!BpmProcessDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 12/10/2015 06:39'!
processId

	^id! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
processInstances
	^processInstances! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
processInstances: newValue
	processInstances := newValue! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/26/2015 18:31'!
processName
	^processName! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/26/2015 18:31'!
processName: newValue
	processName := newValue! !

!BpmProcessDefinition methodsFor: 'fields update' stamp: 'BrunoBB 04/20/2016 17:03'!
removeFrom: formNamed fieldValue: anAppFieldValue
	"The receiver remove from Orbeon form named <formNamed> the field value <anAppFieldValue>.
	The receiver holds a Dictionary with all form's name. Each form's name Dictionary is a Dictionary of fields's name. The value at a given field's name is anUnorderedCollection.
	(formName)>>(fieldName)>>(anUnorderedCollection)"
	| fieldsDictionary fieldCollection |

	fieldsDictionary := (formFieldInstances includesKey: formNamed) 
		ifTrue: [formFieldInstances at: formNamed]
		ifFalse: [^nil].

	fieldCollection := (fieldsDictionary includesKey: anAppFieldValue getKeyName)
		ifTrue: [fieldsDictionary at: anAppFieldValue getKeyName]
		ifFalse: [^nil].

	^fieldCollection remove: anAppFieldValue ifAbsent: [nil]! !

!BpmProcessDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 17:59'!
removeFromAnonymousStart

	^self class anonymousFormMapping 
		removeKey: self getAnonymousFormName 
		ifAbsent: [FormToProcessDefinitionMappingException signal: 'This process is NOT mapped to a Form for an anonymous start']! !

!BpmProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 03/14/2016 10:24'!
removeFromCache
	"Remove the receiver from the global cache of this class"
	| processesDictionary processDefinitions |

	(processName isNil or:[processName isEmpty]) ifTrue: [^NoProcessNameException signal: 'ProcessDefinition MUST have a name'].
	application ifNil: [^NoApplicationException signal: 'ProcessDefinition MUST have an Application'].

	processesDictionary := (self class cache includesKey: application applicationName) "get the dictionary of processes"
			ifTrue: [self class cache at: application applicationName]
			ifFalse: [^NoApplicationException signal: 'No such Process Definition'].

	processDefinitions := (processesDictionary includesKey: processName) "get the collection of versions for definition named <processName>"
			ifTrue: [processesDictionary at: processName] 
			ifFalse: [^AppObjectNotInCacheException signal: 'No such Process Definition'].

	processDefinitions isEmpty ifTrue: [^AppObjectNotInCacheException signal: 'No such Process Definition'].

	(processDefinitions last == self) ifFalse: [^BrokenProcessVersionException signal: 'Remove latest versions first'].

	processDefinitions remove: self ifAbsent: [^AppObjectNotInCacheException signal: 'No such Process Definition'].! !

!BpmProcessDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 11/28/2015 19:59'!
removeProcessInstance: aBpmProcessInstance
	"The receiver remove the process instance <aBpmProcessInstance> from it's collection"

	^processInstances removeKey: aBpmProcessInstance id! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
roles
	^roles! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
roles: newValue
	roles := newValue! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/30/2015 12:53'!
sheetName
	^sheetName! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/30/2015 12:53'!
sheetName: newValue
	sheetName := newValue! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 10/28/2015 12:37'!
startEvent

	^executionPath startEvent! !

!BpmProcessDefinition methodsFor: 'add artifacts' stamp: 'BrunoBB 10/27/2015 17:27'!
startEvent: aBpmStartEventDefinition

	^executionPath startEvent: aBpmStartEventDefinition! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
subProcesses
	^subProcesses! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
subProcesses: newValue
	subProcesses := newValue! !

!BpmProcessDefinition methodsFor: 'instantiation' stamp: 'BrunoBB 11/22/2015 15:54'!
throwNoCreationPermissionExceptionFor: userName

	^NoCreationPermissionException signal: 'The user [', userName, '] has no permission to create instances of this process definition'! !

!BpmProcessDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 18:23'!
toggleAnonymousStart

	self isAnonymousStartEnabled ifTrue: [^self removeFromAnonymousStart].

	^self addToAnonymousStart! !

!BpmProcessDefinition methodsFor: 'fields update' stamp: 'BrunoBB 02/12/2016 06:20'!
updateFieldsOf: formInstanceOrStModel
	"The receiver update the dictionary <formFieldInstances> for each field value in the form <formInstanceOrStModel>"

	formInstanceOrStModel fieldValuesDo: [:fieldValueHolder | 
		"is the first time that fields are going to be processed ? (enter in -false- block only once)"
		fieldValueHolder alreadyAddedToProcessDefinition 
		ifFalse: [fieldValueHolder alreadyAddedToProcessDefinition: true.
					fieldValueHolder currentValues do: [:each | self addTo: formInstanceOrStModel getObjectName fieldValue: each]]
		ifTrue: [
			fieldValueHolder hasElementsToAdd 
			ifTrue: [fieldValueHolder fieldsToAddDo: [:fieldValue |
				self addTo: formInstanceOrStModel getObjectName fieldValue: fieldValue]].

			fieldValueHolder hasElementsToRemove 
			ifTrue: [fieldValueHolder fieldsToRemoveDo: [:fieldValue |
				self removeFrom: formInstanceOrStModel getObjectName fieldValue: fieldValue]].
		].
	].! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
version
	^version! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
version: newValue
	version := newValue! !

!BpmProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 11/02/2015 14:27'!
xmlString
	^xmlString! !

!BpmProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 11/02/2015 14:27'!
xmlString: newValue
	xmlString := newValue! !

BpmProcessDefinition subclass: #BpmSubProcessDefinition
	instanceVariableNames: 'parentProcess triggeredByEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmSubProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 06:49'!
getParentProcessName

	^parentProcess processName! !

!BpmSubProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 04/10/2016 18:50'!
getProcessTree: anOrderedCollection
	"Answer a collection with all process in the tree process structure (parentProcesses and subprocesses)"

	(anOrderedCollection includes: self) ifTrue: [^anOrderedCollection].

	anOrderedCollection add: self.

	subProcesses do: [:each | each getProcessTree: anOrderedCollection].

	parentProcess getProcessTree: anOrderedCollection.

	^anOrderedCollection! !

!BpmSubProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 16:27'!
initialize

	super initialize.

	triggeredByEvent := false! !

!BpmSubProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 17:18'!
isSubProcess

	^true! !

!BpmSubProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:33'!
parentProcess
	^parentProcess! !

!BpmSubProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:33'!
parentProcess: newValue
	parentProcess := newValue! !

!BpmSubProcessDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 11/29/2015 16:28'!
triggeredByEvent
	^triggeredByEvent! !

!BpmSubProcessDefinition methodsFor: 'Updating' stamp: 'BrunoBB 11/29/2015 16:28'!
triggeredByEvent: newValue
	triggeredByEvent := newValue! !

BpmProcessDefinition subclass: #BpmTopProcessDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmTopProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 04/10/2016 17:30'!
canBeStartedByAnonymousForm
	"Answer whether or not the BpmProcessDefinition can be start by sending an anonymous form"

	^executionPath canBeStartedByAnonymousForm! !

!BpmTopProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 06:49'!
getParentProcessName

	^''! !

!BpmTopProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 04/10/2016 18:50'!
getProcessTree: anOrderedCollection
	"Answer a collection with all process in the tree process structure (parentProcesses and subprocesses)"

	(anOrderedCollection includes: self) ifTrue: [^anOrderedCollection].

	anOrderedCollection add: self.

	subProcesses do: [:each | each getProcessTree: anOrderedCollection].

	^anOrderedCollection! !

!BpmTopProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 17:36'!
isTopProcess

	^true! !

!BpmTopProcessDefinition methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 17:36'!
parentProcess
	^nil! !

BpmObject subclass: #BpmProcessPathDefinition
	instanceVariableNames: 'processDefinition transitions startEvent intermediateEvents endEvents tasks gateways subProcessTasks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmProcessPathDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 15:12'!
definition: aBpmProcessDefinition

	^super new initialize
			processDefinition: aBpmProcessDefinition;
			yourself! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:25'!
addEndEvent: aBpmEndEventDefinition

	^endEvents at: aBpmEndEventDefinition name put: aBpmEndEventDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:18'!
addGateway: aBpmGatewayDefinition

	^gateways at: aBpmGatewayDefinition name put: aBpmGatewayDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:25'!
addIntermediateEvent: aBpmIntermediateEventDefinition

	^endEvents at: aBpmIntermediateEventDefinition name put: aBpmIntermediateEventDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:18'!
addSubProcessTask: aBpmSubProcessTaskDefinition

	^subProcessTasks at: aBpmSubProcessTaskDefinition name put: aBpmSubProcessTaskDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:17'!
addTask: aBpmTaskDefinition

	^tasks at: aBpmTaskDefinition name put: aBpmTaskDefinition! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:20'!
addTransition: aBpmTransitionDefinition

	^transitions add: aBpmTransitionDefinition! !

!BpmProcessPathDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 17:44'!
canBeStartedByAnonymousForm
	"Answer whether or not the BpmProcessDefinition can be start by sending an anonymous form"

	processDefinition isSubProcess ifTrue: [^false].

	^(startEvent outTransitions size = 1) and: [startEvent outTransitions allSatisfy: [:each | each endArtifact isOrbeonTask]]! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 04/13/2016 12:11'!
canCreateProcess: aBpmUser
	"Answer whether or not the user <aBpmUser> can create a process instance of the receiver"

	aBpmUser ifNil: [^true]. "a process can be create with anonymous user"

	^(startEvent outTransitions collect: [:trDefinition | trDefinition endArtifact]) 
			anySatisfy: [:artifactDefinition | 
									artifactDefinition hasPerformers "if has performers --> only the first can create the process instance"
									ifFalse: [artifactDefinition isGrantedUser: aBpmUser]
									ifTrue: [aBpmUser includesRoleNamed: artifactDefinition getFirstPerformerName]
			]! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:25'!
endEvents
	^endEvents! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:25'!
endEvents: newValue
	endEvents := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
gateways
	^gateways! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
gateways: newValue
	gateways := newValue! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 14:40'!
getAllArtifacts

	^(OrderedCollection with: startEvent),
			tasks asOrderedCollection,
			gateways asOrderedCollection,
			intermediateEvents asOrderedCollection,
			subProcessTasks asOrderedCollection,
			endEvents asOrderedCollection! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 09:49'!
getAllRoles
	"Answer a collection with all <BpmRole> that perform at least one task in the receiver"
	| allRoles |

	allRoles := OrderedCollection new.

	tasks do: [:each | allRoles addAll: each roles].

	^allRoles! !

!BpmProcessPathDefinition methodsFor: 'anonymous form' stamp: 'BrunoBB 04/10/2016 17:39'!
getAnonymousFormName
	"Answer the name of the anonymous form"
	| taskDefinition |

	self canBeStartedByAnonymousForm 
	ifFalse: [^NoAnonymousStartException signal: 'This process can NOT be started by an anonymous form'].

	taskDefinition := startEvent outTransitions last endArtifact.

	^taskDefinition applicationName, '.', taskDefinition name! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:13'!
getEndEventNamed: aString ifNone: aBlock

	^endEvents at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:12'!
getGatewayNamed: aString ifNone: aBlock

	^gateways at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:13'!
getIntermediateEventNamed: aString ifNone: aBlock

	^intermediateEvents at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:02'!
getNumberOfEndEvents

	^endEvents size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:02'!
getNumberOfGateways

	^gateways size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:02'!
getNumberOfIntermediateEvents

	^intermediateEvents size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:03'!
getNumberOfSubProcessTasks

	^subProcessTasks size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:01'!
getNumberOfTasks

	^tasks size! !

!BpmProcessPathDefinition methodsFor: 'number of' stamp: 'BrunoBB 10/29/2015 14:01'!
getNumberOfTransitions

	^transitions size! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 12/16/2015 13:09'!
getOrderedTasks

	^self getOrderedTasksFrom: startEvent as: OrderedCollection new! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 12/16/2015 13:21'!
getOrderedTasksFrom: anArtifactDefinition as: anOrderedCollection
	| newArtifacts |

	newArtifacts := anArtifactDefinition outTransitions collect: [:each | each endArtifact].
	newArtifacts := newArtifacts difference: anOrderedCollection.

	anOrderedCollection addAll: (newArtifacts select: [:each | each isTaskDefinition]).

	newArtifacts do: [:each | self getOrderedTasksFrom: each as: anOrderedCollection].

	^anOrderedCollection! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:13'!
getSubProcessTaskNamed: aString ifNone: aBlock

	^subProcessTasks at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/28/2015 12:12'!
getTaskNamed: aString ifNone: aBlock

	^tasks at: aString ifAbsent: aBlock! !

!BpmProcessPathDefinition methodsFor: 'get artifacts' stamp: 'BrunoBB 10/30/2015 05:44'!
getTransitionNamed: aString ifNone: aBlock

	^transitions detect: [:each | each name = aString] ifNone: aBlock! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 04/19/2016 16:19'!
hasGatewayConditionIncludingFieldNamed: fieldName
	"Answer whether or not the receiver has a <BpmGatewayDefinition> with condition that includes a field named <fieldName>"

	^gateways anySatisfy: [:each | each hasEvaluationConditionWithFieldNamed: fieldName]! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 01/23/2016 07:26'!
hasOrbeonFormNamed: aString
	"The receiver answer whether or not it hold a form <OrbeonFormDefinition> named <aString>"

	^(self hasTaskNamed: aString) and: [(self getTaskNamed: aString ifNone: [^false]) isOrbeonTask]! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 12/21/2015 09:48'!
hasTaskNamed: aString

	^self tasks anySatisfy: [:each | each name = aString]! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:25'!
initialize

	super initialize.

	transitions := OrderedCollection new.
	intermediateEvents := Dictionary new.	
	endEvents := Dictionary new.
	tasks := Dictionary new.
	gateways := Dictionary new.
	subProcessTasks := Dictionary new.! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:25'!
intermediateEvents
	^intermediateEvents! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:25'!
intermediateEvents: newValue
	intermediateEvents := newValue! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:39'!
printArtifacts
	| stream  |

	stream := WriteStream on: String new.

	self getAllArtifacts do: [:each | 
		each printOn: stream.
		stream nextPut: Character lf].

	^stream contents! !

!BpmProcessPathDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:32'!
printTransitions
	| stream  |

	stream := WriteStream on: String new.

	transitions do: [:each | 
		each printOn: stream.
		stream nextPut: Character lf].

	^stream contents! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:11'!
processDefinition
	^processDefinition! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:11'!
processDefinition: newValue
	processDefinition := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:25'!
startEvent
	^startEvent! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:25'!
startEvent: newValue
	startEvent := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
subProcessTasks
	^subProcessTasks! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
subProcessTasks: newValue
	subProcessTasks := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
tasks
	^tasks! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
tasks: newValue
	tasks := newValue! !

!BpmProcessPathDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 15:21'!
transitions
	^transitions! !

!BpmProcessPathDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 15:21'!
transitions: newValue
	transitions := newValue! !

BpmObject subclass: #BpmRole
	instanceVariableNames: 'name users isAdmin application orbeonApplication tasks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmRole subclass: #BpmBackofficeRole
	instanceVariableNames: ''
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmBackofficeRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:38'!
cache

	Cache ifNil: [Cache := Dictionary new].

	^Cache! !

!BpmBackofficeRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:38'!
cache: aDictionary

	Cache := aDictionary! !

!BpmBackofficeRole class methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 10:56'!
getAllRoles
	| allRols |

	allRols := OrderedCollection new.

	BpmBackofficeRole cache asOrderedCollection do: [:each | allRols addAll: each].

	^allRols! !

!BpmBackofficeRole methodsFor: 'other' stamp: 'BrunoBB 12/18/2015 14:27'!
asBackofficeRole

	^self! !

!BpmBackofficeRole methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 14:42'!
asFrontofficeRole

	^BpmFrontOfficeRole new
		name: name;
		isAdmin: isAdmin;
		application: application;
		yourself! !

!BpmBackofficeRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:35'!
isBackofficeRole

	^true! !

!BpmBackofficeRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:35'!
isBackofficeUserAndAdmin

	^isAdmin! !

BpmRole subclass: #BpmFrontOfficeRole
	instanceVariableNames: ''
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmFrontOfficeRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 18:46'!
cache

	Cache ifNil: [Cache := Dictionary new].

	^Cache! !

!BpmFrontOfficeRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 18:46'!
cache: aDictionary

	Cache := aDictionary! !

!BpmFrontOfficeRole class methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 10:24'!
getAllRoles
	| allRols |

	allRols := OrderedCollection new.

	BpmFrontOfficeRole cache asOrderedCollection do: [:each | allRols addAll: each].

	^allRols! !

!BpmFrontOfficeRole methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 14:42'!
asBackofficeRole

	^BpmBackofficeRole new
		name: name;
		isAdmin: isAdmin;
		application: application;
		yourself! !

!BpmFrontOfficeRole methodsFor: 'other' stamp: 'BrunoBB 12/18/2015 14:27'!
asFrontofficeRole

	^self! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 11/22/2015 15:11'!
createNewOrGetExisting: roleName in: appName
	"The receiver creates a new <BpmRole> named <roleName> or get the existing role from OrbeonApplication <appName>"

	^(self getRoleNamed: roleName in: appName)
		ifNotNil: [:bpmRole | bpmRole]
		ifNil: [(self newNamed: roleName) addToCacheInAppName: appName].! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 10:56'!
getAllRoles
	| allRols |

	allRols := OrderedCollection new.

	(BpmFrontOfficeRole cache asOrderedCollection, BpmBackofficeRole cache asOrderedCollection) 
	do: [:each | allRols addAll: each].

	^allRols! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:39'!
getAnyRoleNamed: aString

	^self getAllRoles detect: [:each | each name = aString] ifNone: [nil]! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 11/22/2015 15:04'!
getRoleNamed: roleName in: appName

	(self cache includesKey: appName) ifFalse: [^nil].

	^(self cache at: appName) detect: [:each | each name = roleName] ifNone: [nil]! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 17:17'!
getRolsInApp: anOrbeonApplication

	^self getAllRoles select: [:each | each application == anOrbeonApplication]! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 02/29/2016 09:59'!
getRolsInAppName: appName

	^(self getAllRoles select: [:each | each getApplicationName = appName]) asOrderedCollection! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 01/20/2016 11:27'!
hasRoleNamed: aString in: anOrbeonApplication

	^((self getRolsInApp: anOrbeonApplication) select: [:each | each name = aString]) notEmpty! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 03/10/2016 08:21'!
initializeCache

	self cache: RcKeyValueDictionary new! !

!BpmRole class methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:43'!
newNamed: aString

	^super new initialize
			name: aString;
			yourself! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 09:32'!
addResponsibility: aBpmArtifactDefinition

	^tasks at: aBpmArtifactDefinition name put: aBpmArtifactDefinition! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 12:21'!
addToCacheInAppName: aString
	"The receiver is added to the global Role cache for the an OrbeonApplication named <aString>"
	| roleCollection |

	application := self getApplicationManagerClass getAnyApplicationNamed: aString ifNone: [^NoApplicationException signal: 'No Orbeon Application named <', aString, '>'].

	"get the role's collection for the OrbeonApplication named <aString>"
	(self class cache includesKey: aString) ifFalse: [self class cache at: aString put: RcIdentityBag new].

	roleCollection := self class cache at: aString. 

	"NOT possible to add two roles with the same name"
	^roleCollection detect: [:each | name = each name] ifNone: [roleCollection add: self].! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 02/08/2016 14:39'!
application
	^application! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 02/08/2016 14:39'!
application: newValue
	application := newValue! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 03/12/2016 15:50'!
canDelete
	"Answer whether or not the receiver can be deleted from the system"

	^tasks isEmpty and: [users isEmpty]! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 14:39'!
getApplicationName

	^application applicationName! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 09:46'!
getProcessDefinitions
	"Answer a collection of <BpmProcessDefinition> where the receiver perform at least one task"! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 02/24/2016 16:29'!
grantUser: aBpmUser

	users at: aBpmUser username put: aBpmUser.

	^aBpmUser addRole: self! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:32'!
initialize

	super initialize.

	name := ''.
	users := Dictionary new.
	tasks := Dictionary new.
	isAdmin := false.! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
isAdmin
	^isAdmin! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
isAdmin: newValue
	isAdmin := newValue! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:35'!
isBackofficeRole

	^false! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 14:35'!
isBackofficeUserAndAdmin

	^false! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 11/22/2015 15:48'!
isGranted: aBpmUser

	^users includes: aBpmUser! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
name
	^name! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
name: newValue
	name := newValue! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
orbeonApplication
	^orbeonApplication! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
orbeonApplication: newValue
	orbeonApplication := newValue! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 19:37'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[', name, ']'! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 10:04'!
removeAllUsers
	"The receiver ungrant all users"
	| allUsers |

	allUsers := OrderedCollection withAll: users.

	allUsers do: [:each | self ungrantUser: each].! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 04/11/2016 10:23'!
removeFromCache
	"The receiver is added to the global Role cache for the an OrbeonApplication named <aString>"

	^self removeFromCacheInAppName: application applicationName! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 03/09/2016 12:58'!
removeFromCacheInAppName: aString
	"The receiver is added to the global Role cache for the an OrbeonApplication named <aString>"

	application := self getApplicationManagerClass getAnyApplicationNamed: aString ifNone: [^NoApplicationException signal: 'No Application named <', aString, '>'].

	^(self class cache at: aString) remove: self ifAbsent: [^NoSuchRoleException signal: 'No Role named <', name, '>'].! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 12/22/2015 10:19'!
removeResponsibility: aBpmArtifactDefinition

	^tasks removeKey: aBpmArtifactDefinition name 
				ifAbsent: [NoSuchActivitytException signal: 'No such Activity Definition in [', aBpmArtifactDefinition name, ']']! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
tasks
	^tasks! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
tasks: newValue
	tasks := newValue! !

!BpmRole methodsFor: 'other' stamp: 'BrunoBB 02/24/2016 16:29'!
ungrantUser: aBpmUser

	users removeKey: aBpmUser username ifAbsent: [].

	^aBpmUser removeRole: self! !

!BpmRole methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 14:32'!
users
	^users! !

!BpmRole methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 14:32'!
users: newValue
	users := newValue! !

BpmObject subclass: #BpmTaskLoop
	instanceVariableNames: 'taskDefinition startQuantity completionQuantity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

BpmTaskLoop subclass: #BpmMultiInstanceTaskLoop
	instanceVariableNames: 'loopCardinality isSequential'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmMultiInstanceTaskLoop commentStamp: 'BrunoBB 10/31/2015 10:59' prior: 0!
Multinstance - each time a transition trigger the a task --> a new instance of the <externalObject> is created.

loopCardinality - anInteger expression!

!BpmMultiInstanceTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
getLoop

	^loopCardinality! !

!BpmMultiInstanceTaskLoop methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 11:01'!
initialize

	super initialize.

	loopCardinality := nil. "anInteger expression"
	isSequential := true. "false --> instances are created in parralel"! !

!BpmMultiInstanceTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:19'!
isMultiInstance

	^true! !

!BpmMultiInstanceTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:00'!
isSequential
	^isSequential! !

!BpmMultiInstanceTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 11:00'!
isSequential: newValue
	isSequential := newValue! !

!BpmMultiInstanceTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:00'!
loopCardinality
	^loopCardinality! !

!BpmMultiInstanceTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 11:00'!
loopCardinality: newValue
	loopCardinality := newValue! !

!BpmMultiInstanceTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:46'!
setLoop: aStringBlock

	loopCardinality := aStringBlock! !

BpmTaskLoop subclass: #BpmNoneTaskLoop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmNoneTaskLoop commentStamp: '' prior: 0!
None - each time a transition trigger the a task --> the only instance of <externalObject> is edited.!

!BpmNoneTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
getLoop

	^nil! !

!BpmNoneTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:19'!
isNone

	^true! !

!BpmNoneTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:47'!
setLoop: aStringBlock! !

BpmTaskLoop subclass: #BpmStandartTaskLoop
	instanceVariableNames: 'loopCondition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmStandartTaskLoop commentStamp: 'BrunoBB 10/31/2015 11:02' prior: 0!
Standart - each time a transition trigger the a task --> the only instance of <externalObject> is edited.

loopCondition - aBoolean expression!

!BpmStandartTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
getLoop

	^loopCondition! !

!BpmStandartTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:19'!
isStandart

	^true! !

!BpmStandartTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 10:52'!
loopCondition
	^loopCondition! !

!BpmStandartTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 10:52'!
loopCondition: newValue
	loopCondition := newValue! !

!BpmStandartTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:47'!
setLoop: aStringBlock

	loopCondition := aStringBlock! !

!BpmTaskLoop class methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:47'!
for: aBpmTaskDefinition

	^super new initialize
		taskDefinition: aBpmTaskDefinition;
		yourself! !

!BpmTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:02'!
completionQuantity
	^completionQuantity! !

!BpmTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 11:02'!
completionQuantity: newValue
	completionQuantity := newValue! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
getLoop

	self subclassResponsibility! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 10:10'!
initialize

	super initialize.

	startQuantity := 1.
	completionQuantity := 1.! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:19'!
isMultiInstance

	^false! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
isNone

	^false! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/02/2015 08:18'!
isStandart

	^false! !

!BpmTaskLoop methodsFor: 'other' stamp: 'BrunoBB 11/01/2015 14:46'!
setLoop: aStringBlock

	self subclassResponsibility! !

!BpmTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:02'!
startQuantity
	^startQuantity! !

!BpmTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 11/02/2015 08:31'!
startQuantity: newValue

	newValue ifNil: [^startQuantity := 1]. "when this value is absent --> it can be assumed that is 1 -one-"

	startQuantity := newValue! !

!BpmTaskLoop methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 11:02'!
taskDefinition
	^taskDefinition! !

!BpmTaskLoop methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 11:02'!
taskDefinition: newValue
	taskDefinition := newValue! !

BpmObject subclass: #BpmTransitionDefinition
	instanceVariableNames: 'processDefinition name startArtifact endArtifact conditionToRun extendedAttributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMCore'!

!BpmTransitionDefinition class methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 15:46'!
process: aBpmProcessDefinition

	^super new initialize
		processDefinition: aBpmProcessDefinition;
		yourself! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 10/27/2015 17:31'!
addToParentProcess

	^processDefinition addTransition: self! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/29/2015 13:08'!
conditionToRun
	^conditionToRun! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/29/2015 13:08'!
conditionToRun: newValue
	conditionToRun := newValue! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:30'!
endArtifact
	^endArtifact! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:30'!
endArtifact: newValue
	endArtifact := newValue! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 11/25/2015 11:09'!
evaluateConditionIn: aBpmProcessInstance
	"The receiver evaluates the condition <conditionToRun> in the context of the object <aBpmProcessInstance>"
	| evaluationResult |

	evaluationResult := conditionToRun evaluateConditionIn: aBpmProcessInstance.

	evaluationResult hasException
	ifTrue: [evaluationResult addToCache].

	^evaluationResult result! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 12/13/2015 13:47'!
extendedAttributes
	^extendedAttributes! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 13:47'!
extendedAttributes: newValue
	extendedAttributes := newValue! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:47'!
extendedValueOf: attrName

	^extendedAttributes at: attrName ifAbsent: [nil]! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:47'!
extendedValueOf: attrName ifAbsent: aBlock

	^extendedAttributes at: attrName ifAbsent: aBlock! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 13:08'!
hasCondition

	^conditionToRun notNil! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 04/19/2016 16:20'!
hasEvaluationConditionWithFieldNamed: fieldName
	"Answer whether or not the field named <fieldName> is included in the evaluation expression of the receiver"

	^conditionToRun hasEvaluationConditionWithFieldNamed: fieldName! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 12/13/2015 13:47'!
initialize

	super initialize.

	extendedAttributes := Dictionary new.! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/28/2015 13:55'!
name
	^name! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 13:55'!
name: newValue
	name := newValue! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 07:02'!
printData
	| stream |

	stream := PrintStream on: String new.

	conditionToRun hasEvaluation
	ifTrue: [stream nextPutAll: '(c)', String lf;
					nextPutAll: conditionToRun evaluationCode, String lf.].

	stream nextPutAll: (startArtifact name, '>>', endArtifact name), String lf.

"	(expectedResult notNil and: [expectedResult notEmpty])
	ifTrue: [stream nextPutAll: '(Expected Result)', String lf;
					nextPutAll: self printExpectedResult, String lf.].

	(previousFields notNil and: [previousFields notEmpty])
	ifTrue: [stream nextPutAll: '(Previous Fields)', String lf;
					nextPutAll: self printPreviousFields, String lf.]."

	^stream contents! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 10/28/2015 14:35'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[', name, '] {(', startArtifact printOnType, ')',startArtifact name, '} >> {(', endArtifact printOnType, ')', endArtifact name, '}'.! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:30'!
processDefinition
	^processDefinition! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:30'!
processDefinition: newValue
	processDefinition := newValue! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:47'!
removeExtendedAttribute: attrName 

	^extendedAttributes removeKey: attrName ifAbsent: []! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 10/29/2015 13:11'!
setCondition: aString

	conditionToRun := BpmCodeCondition code: aString! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 12:22'!
setEndArtifact: aBpmArtifactDefinition

	endArtifact := aBpmArtifactDefinition.

	aBpmArtifactDefinition addInTransition: self! !

!BpmTransitionDefinition methodsFor: 'other' stamp: 'BrunoBB 12/13/2015 13:47'!
setExtended: attrName value: anObject

	^extendedAttributes at: attrName put: anObject! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/28/2015 12:22'!
setStartArtifact: aBpmArtifactDefinition

	startArtifact := aBpmArtifactDefinition.

	aBpmArtifactDefinition addOutTransition: self! !

!BpmTransitionDefinition methodsFor: 'Accessing' stamp: 'BrunoBB 10/27/2015 17:30'!
startArtifact
	^startArtifact! !

!BpmTransitionDefinition methodsFor: 'Updating' stamp: 'BrunoBB 10/27/2015 17:30'!
startArtifact: newValue
	startArtifact := newValue! !

!Object class methodsFor: '*orbeonBPMCore' stamp: 'BrunoBB 02/08/2016 13:40'!
getBpmApplicationClass
	"The receiver answer the class used as Bpm applications holder"

	^BpmApplication! !

!Object class methodsFor: '*orbeonBPMCore' stamp: 'BrunoBB 02/26/2016 13:46'!
getBpmCache
	"The receiver answer the class used as Bpm applications holder"

	^AbstractApplication getBpmCache! !

!Object methodsFor: '*orbeonBPMCore' stamp: 'BrunoBB 02/08/2016 13:41'!
getBpmApplicationClass
	"The receiver answer the class used as Bpm applications holder"

	^self class getBpmApplicationClass! !

!Object methodsFor: '*orbeonBPMCore' stamp: 'BrunoBB 02/26/2016 13:47'!
getBpmCache

	^self class getBpmCache! !
